//********************************************************************************************
// RC Model Servo
// Written By EAOROBBIE (Robert Lindsay)
// For free use for Sim Tool Motion Software
//********************************************************************************************

#include <Servo.h> 
 
Servo myservo1;    // create servo object to control a servo 
Servo myservo2;    // create servo object to control a servo
char kind_of_data; // to capture which servo needs to be move
int valLSP = 90;   // set the intial Left Servo Position to centre
int valRSP = 90;   // set the intial Right Servo Position to centre

void setup() 
{ 
  myservo1.attach(4);      // attaches the servo on pin 5 to the servo object 
  myservo2.attach(5);      // attaches the servo on pin 4 to the servo object
  myservo1.write(valLSP);  // sets the servo position according to the scaled value
  myservo2.write(valRSP;   // set the servo position according to the scaled value
 
  Serial.begin(9600);      // opens serial port at a baud rate of 9600
} 
 
void loop() 
{ 
  
  //****************************** READ DATA FROM SERIAL ******************************
  while (Serial.available() > 0)
  {

    kind_of_data = Serial.read();
    if (kind_of_data == 'R' ) Read_RightServo();
    if (kind_of_data == 'L' ) Read_LeftServo();
    
   
  
  myservo1.write(valRSP);                  // sets the servo position according to the scaled value
  myservo2.write(valLSP);                  // sets the servo position according to the scaled value 
  } 
}

void Read_RightServo(){

  int RightServoPos = 0;
  delay(2);
  int RSP100 = Serial.read();
  delay(2);
  int RSP10 = Serial.read();
  delay(2);
  int RSP1= Serial.read();
  
  RSP100 = ((RSP100)-48)*100;
  RSP10  = ((RSP10)-48)*10;
  RSP1   = ((RSP1)-48)*1;
  if (RSP10 < 0 && RSP1 < 0){RSP100 = RSP100/100;RSP10 = 0;RSP1 = 0;}
  if (RSP1 < 0){RSP100 = RSP100/10;RSP10 = RSP10/10;RSP1 = 0;}
  //Serial.println(RSP100);   // these are here for debugging purposes
  //Serial.println(RSP10);    // these are here for debugging purposes
  //Serial.println(RSP1);     // these are here for debugging purposes
  RightServoPos = RSP100+RSP10+RSP1;
  valRSP = map(RightServoPos, 0, 255, 0, 179);     // scale it to use it with the servo (value between 0 and 180)
  //Serial.println(RightServoPos);   // these are here for debugging purposes
  //Serial.println(valRSP);          // these are here for debugging purposes
  
}

void Read_LeftServo(){

  int LeftServoPos = 0;
  delay(2);
  int LSP100 = Serial.read();
  delay(2);
  int LSP10 = Serial.read();
  delay(2);
  int LSP1= Serial.read();
  
  LSP100 = ((LSP100)-48)*100;
  LSP10  = ((LSP10)-48)*10;
  LSP1   = ((LSP1)-48)*1;
  if (LSP10 < 0 && LSP1 < 0){LSP100 = LSP100/100;LSP10 = 0;LSP1 = 0;}
  if (LSP1 < 0){LSP100 = LSP100/10;LSP10 = LSP10/10;LSP1 = 0;}
  //Serial.println(LSP100);    // these are here for debugging purposes
  //Serial.println(LSP10);     // these are here for debugging purposes
  //Serial.println(LSP1);      // these are here for debugging purposes
  LeftServoPos = LSP100+LSP10+LSP1;
  valLSP = map(LeftServoPos, 0, 255, 179, 0);     // scale it to use it with the servo (value between 0 and 180)
  //Serial.println(LeftServoPos);   // these are here for debugging purposes
  //Serial.println(valLSP);         // these are here for debugging purposes
}
